//
//
//
#include "defines.h"

//
//
//
void resultsInit(results *r)
{
  r->noFr = 0;
  r->snr_y = 0.0;
  r->snrAll = 0.0;
  r->bits = 0;
  r->bitAll = 0;
}

//
//
//
void resultsEnd(results r)
{
  fflush(r.dataFile);
  fclose(r.dataFile);
}

//
//
//
void printResults(results *r, int no)
{
  (r->noFr)++;
  printf("%3d %6.3f %d\n", no, r->snr_y, r->bits);
  fflush(stdout);
  fflush(stderr);
  r->snrAll += r->snr_y;
  r->bitAll += r->bits;
  r->bits = 0;
  r->snr_y = 0.0;
}

//
//
//
void updateBits(results *r, int b)
{
  r->bits += b;
}

//
//
//
void printResultsFinal(results *r)
{
  r->snrAll /= r->noFr;
  printf("Total frames %d\t Average PSNR_Y %6.3f\t Total bits %d\n", r->noFr, r->snrAll, r->bitAll); 
  if((r->dataFile = fopen("Data.txt", "a")) == 0)
  {
    printf("Error open file %s\n", "Data.txt");
    exit(0);
  } 
  fprintf(r->dataFile, "%d\t%6.3f\t%d\n", r->noFr, r->snrAll, r->bitAll); 
}

//
//  Calculate PSNR_Y
//
void find_snr(results *r, imgpel **imgY_org, imgpel **imgY_rec, int height, int width)
{
  int i, j;
  int diff_y = 0;
  int impix = height * width;

  r->snr_y = 0.0;

  // SNR on Luma
  for(i = 0; i < width; ++i)
    for(j = 0; j < height; ++j)
      diff_y += (imgY_org[j][i] - imgY_rec[j][i]) * (imgY_org[j][i] - imgY_rec[j][i]);

  if(diff_y != 0)
    r->snr_y = (double)(10 * log10(65025 * (double)impix / (double)diff_y));  
}
